<template>
<div class="w-100">
    <v-sheet v-if="!initialized && loading" color="grey lighten-4 " class="px-3 pt-3 pb-12">
          <v-responsive
      max-width="100%"
      class="mx-auto"
    >
      <v-skeleton-loader
        ref="skeleton"
        type="table"
        class="mx-auto"
      ></v-skeleton-loader>
       </v-responsive>
  </v-sheet>
  <v-data-table v-else
    :headers="headers"
    v-model="selected"
    :loading="loading"
    :loader-height=3
    show-select
    item-key="name"
    :items="items"
    :single-select="singleSelect"
    sort-by="name"
    :search="search"
    :single-expand="singleExpand"
    :expanded.sync="expanded"
    class="elevation-1 w-100"
  >
      <template v-slot:item.patient="{ item }">
        <b> <span v-if=" item.patient.isMale" >M. </span><span v-else >Mme </span>{{ item.patient.firstname  }} {{ item.patient.lastname  }}</b>
        <p style="margin-bottom:2px;margin-top:2px;line-height: 10px;"><small><span v-if=" item.patient.isMale" >Né</span><span v-else >Née</span>  : {{ item.patient.birthdate  }}</small> </p>
        <p style="margin-bottom:4px;line-height: 10px;"><small><span  >Contact :</span> {{ item.patient.phone_number ? item.patient.phone_number :'Aucun contact'  }}</small> </p>
     </template>
    <template v-slot:item.name_physician="{ item }">
        <p style="margin-bottom:2px;margin-top:2px;line-height: 10px;">{{item.name_physician}} </p>
        <p style="margin-bottom:4px;line-height: 10px;"><small><span  >hospital :</span> {{ item.hospital }}</small> </p>
     </template>
    <template v-slot:item.status="{ item }">
             <v-chip class="text-uppercase text-center d-inline-block w-100" small  label :color="getColor(item.status)" dark>{{ item.status }}</v-chip>
    </template>
    <template v-slot:expanded-item="{ headers, item }">
      <td :colspan="headers.length">More info about {{ item.name }}</td>
    </template>
    <template v-slot:top>
      <v-toolbar flat color="white">
        <v-toolbar-title>Demandes d'examen</v-toolbar-title>
            <v-btn small to="/nouvelle-demande"
              color="secondary"
              dark
              class="mb-2 ml-1 mt-2 decoration-none"
              v-bind="attrs"
              v-on="on"
            >
              Nouveau</v-btn>

            <v-spacer></v-spacer>
                <v-text-field
                      v-model="search"
                      class="mb-2"
                      append-icon="mdi-magnify"
                      label="Recherche"
                      single-line
                      hide-details
              ></v-text-field>
      </v-toolbar>
    </template>
    <template v-slot:item.actions="{ item }">
            <v-icon
        small
        class="mr-2"
        @click="seeDemand(item)"
      >
        mdi-eye
      </v-icon>
      <v-icon
        small
        class="mr-2"
        @click="editItem(item)"
      >
        mdi-pencil
      </v-icon>
      <v-icon
        small
        @click="deleteItem(item)"
      >
        mdi-delete
      </v-icon>
    </template>
    <template v-slot:no-data>
      <!-- <v-btn color="primary" @click="initialize">Reset</v-btn> -->
    </template>
    <template v-slot:left>
      <v-switch v-model="singleSelect" label="Single select" class="pa-3"></v-switch>
    </template>
  </v-data-table>
</div>
</template>

<script>
  
  import { mapGetters } from 'vuex'

  export default {
    data: () => ({
      e1: 1,
      search: '',
      form : new Form({
          old_patient:false,
           patient:
           {
              id:"",
              lastname: '',
              firstname: "",
              phone_number: "",
              birthdate: "",
              genre: "",
              assurances:[]
           },
           exams:[],
      }),
      assurances: ['CNAMGS','ASCOMA'],
      type_demandes: ['Bactoriologique'],
      demandes : [],
      dataFilters: {},
      dialog: false,
      singleSelect: false,
      selected: [],
      expanded: [],
      singleExpand: false,
      gridConfig: {
        records: [],
        loading: true,
        options: {
          itemsPerPageOptions: [10, 25, 50, 100],
          totalPages: 0,
          itemsPerPage: 10,
          page: 1,
          descending: false,
        }
      },
      headers: [
        {
          text: 'N°',
          align: 'left',
          sortable: true,
          value: 'file_number',
        },
        { text: 'Identité du patient', value: 'patient' },
        { text: 'Assurance', value: '' },
        { text: 'Medécin', value: 'name_physician',align:"left" },
        { text: 'Statut', value: 'status',align:"center" },
         { text: 'Date de création', value: 'created_at' },
        { text: 'Actions', value: 'actions', sortable: false },
      ],
      desserts: [],
      editedIndex: -1,
      editedItem: {
        name: '',
        calories: 0,
        assurance: 0,
        TM: 0,
        GAP: 0,
      },
      defaultItem: {
        name: '',
        calories: 0,
        assurance: 0,
        TM: 0,
        GAP: 0,
      },
    }),

    computed: {
       ...mapGetters({initialized:'demands/initialized',insurances:'params/_insurances', moreExists:'demands/moreExists',next_page_url:"demands/next_page_url",total:"demands/total"
                           ,current_page:"demands/current_page",items:"demands/_items",loading:"demands/loading",loaded:"demands/loaded"}),

      formTitle () {
        return this.editedIndex === -1 ? "Nouvelle Demande" : "Modification de la demande"
      },
    },

    watch: {
      dialog (val) {
        val || this.close()
      },
    },

    created () {
      // this.initialize()
    //  window.event.$emit("isLoading",true)
      this.$store.dispatch('demands/init')
      this.$store.dispatch('demands/getDemands')
      console.log('init')
    },

    methods: {
      getColor (status) {
        if (status=="Enregistré") return 'orange'
        else if (status=="En cours") return 'blue'
        else if (status=="Annulé") return 'silver'
        else if (status=="Traité") return 'green'
        else return 'silver'
      },

      addExamen () {

      },

      editItem (item) {
        this.editedIndex = this.items.indexOf(item)
        this.editedItem = Object.assign({}, item)
        this.dialog = true
      },
      seeDemand (item) {
          //alert('Voir demande')
          var id = item.id
          this.$router.push({ name: 'demand-detail', params: { id } })
      },
      deleteItem (item) {
        const index = this.items.indexOf(item)
        confirm('Etes-vous de vouloir supprimer cet element?') && this.items.splice(index, 1)
      },

      close () {
        this.dialog = false
        this.$nextTick(() => {
          this.editedItem = Object.assign({}, this.defaultItem)
          this.editedIndex = -1
        })
      },

      save () {
        if (this.editedIndex > -1)
        {
          Object.assign(this.items[this.editedIndex], this.editedItem)
        }
        else 
        {
          this.items.push(this.editedItem)
        }
        this.close()
      },

    disableAddInsuranceButton()
      {
        if(this.editedItem)
        return this.editedItem.demandes.length >= 3 ;
        else
        return false
      },
      //Ajoute une assurance temporaire
       addInsurance ()
       {
         if(!this.disableAddInsuranceButton)
         this.editedItem.demandes.push({insurance_id:"",insurance_number:""})
       },
        //Retire une assurance de la liste
       removeInsurance (key)
       {
         this.editedItem.demandes.splice(key,1)
       },
    },
  }
</script>
